PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Classes | Protected Member Functions | List of all members
PSet< T > Class Template Reference

This template class maps the `PAbstractSet` to a specific object type. More...

`#include <dict.h>`

Inheritance diagram for PSet< T >:
[legend]
Collaboration diagram for PSet< T >:
[legend]

## Classes
class | const_iterator
class | iterator
class | iterator_base

## Public Member Functions
Construction
| PSet (PBoolean initialDeleteObjects=false)
| Create a new, empty, dictionary. More...
Overrides from class PObject
virtual PObject * | Clone () const
| Make a complete duplicate of the set. More...
New functions for class
void | Include (const T *obj)
| Include the specified object into the set. More...
PSet & | operator+= (const T &obj)
| Include the specified objects value into the set. More...
void | Exclude (const T *obj)
| Remove the object from the set. More...
PSet & | operator-= (const T &obj)
| Remove the objects value from the set. More...
PBoolean | Contains (const T &key) const
| Determine if the value of the object is contained in the set. More...
PBoolean | operator[] (const T &key) const
| Determine if the value of the object is contained in the set. More...
virtual const T & | GetKeyAt (PINDEX index) const
| Get the key in the set at the ordinal index position. More...
Iterators
iterator | begin ()
iterator | end ()
iterator | find (const T &k)
const_iterator | begin () const
const_iterator | end () const
const_iterator | find (const T &k) const
void | erase (const iterator &it)
void | erase (const const_iterator &it)
Public Member Functions inherited from PAbstractSet
PINLINE | PAbstractSet ()
| Create a new, empty, set. More...
virtual PINDEX | Append (PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Add a new object to the collection. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove an object at the specified index. More...
virtual PObject * | GetAt (PINDEX index) const
| This function is the same as PHashTable::AbstractGetKeyAt(). More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Add a new object to the collection. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
bool | Union (const PAbstractSet &set)
| Calculate union of sets. More...
Public Member Functions inherited from PHashTable
| PHashTable ()
| Create a new, empty, hash table. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two hash tables. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for hash table. More...
PINLINE PBoolean | AbstractContains (const PObject &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual const PObject & | AbstractGetKeyAt (PINDEX index) const
| Get the key in the hash table at the ordinal index position. More...
virtual PObject & | AbstractGetDataAt (PINDEX index) const
| Get the data in the hash table at the ordinal index position. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
| PSet (int dummy, const PSet *c)

## Additional Inherited Members
Public Types inherited from PHashTable
typedef PHashTableElement | Element
typedef PHashTableInfo | Table
Static Public Member Functions inherited from PAbstractSet
static bool | Intersection (const PAbstractSet &set1, const PAbstractSet &set2, PAbstractSet *intersection=NULL)
| Calculate intersection of sets. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Public Attributes inherited from PHashTable
PHashTableInfo * | hashTable
Protected Attributes inherited from PContainer
PContainerReference * | reference
Friends inherited from PObject

## Detailed Description

### template<class T>
class PSet< T >

This template class maps the `PAbstractSet` to a specific object type.

The functions in this class primarily do all the appropriate casting of types.

By default, objects placed into the set will not be deleted when removed or when all references to the set are destroyed. This is different from the default on most collection classes.

Note that if templates are not used the `PDECLARE_SET` macro will simulate the template instantiation.

## Constructor & Destructor Documentation

template<class T>

PSet< T >::PSet | ( | PBoolean | initialDeleteObjects = `false` | ) |
| inline

Create a new, empty, dictionary.

The parameter indicates whether to delete objects that are removed from the set.

Note that by default, objects placed into the set will not be deleted when removed or when all references to the set are destroyed. This is different from the default on most collection classes.

Referenced by PSet< PString >::Clone().

template<class T>

PSet< T >::PSet | ( | int | dummy,
|  | const PSet< T > * | c
| ) |  |
| inline protected

## Member Function Documentation

template<class T>

iterator PSet< T >::begin | ( |  | ) |
| inline

template<class T>

const_iterator PSet< T >::begin | ( |  | ) | const
| inline

template<class T>

virtual PObject* PSet< T >::Clone | ( |  | ) | const
| inline virtual

Make a complete duplicate of the set.

Note that all objects in the array are also cloned, so this will make a complete copy of the set.

Reimplemented from PObject.

Reimplemented in PStringSet.

template<class T>

PBoolean PSet< T >::Contains | ( | const T & | key | ) | const
| inline

Determine if the value of the object is contained in the set.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

Returns
  true if the object value is in the set.

Parameters

  key | Key to look for in the set.

template<class T>

iterator PSet< T >::end | ( |  | ) |
| inline

template<class T>

const_iterator PSet< T >::end | ( |  | ) | const
| inline

template<class T>

void PSet< T >::erase | ( | const iterator & | it | ) |
| inline

Referenced by PSet< PString >::operator-=().

template<class T>

void PSet< T >::erase | ( | const const_iterator & | it | ) |
| inline

template<class T>

void PSet< T >::Exclude | ( | const T * | obj | ) |
| inline

Remove the object from the set.

If the `AllowDeleteObjects` option is set then the object is also deleted.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

template<class T>

iterator PSet< T >::find | ( | const T & | k | ) |
| inline

Referenced by PSet< PString >::operator-=().

template<class T>

const_iterator PSet< T >::find | ( | const T & | k | ) | const
| inline

template<class T>

virtual const T& PSet< T >::GetKeyAt | ( | PINDEX | index | ) | const
| inline virtual

Get the key in the set at the ordinal index position.

The ordinal position in the set is determined by the hash values of the keys and the order of insertion.

WARNING: this code requires a linear search for every operation and will be VERY slow for large data sets. This function is kept for backwards compatibilty only. New code should use the iterator based access methods

Returns
  reference to key at the index position.

Parameters

  index | Index of value to get.

template<class T>

void PSet< T >::Include | ( | const T * | obj | ) |
| inline

Include the specified object into the set.

If the objects value is already in the set then the object is not included. If the `AllowDeleteObjects` option is set then the `obj` parameter is also deleted.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

template<class T>

PSet& PSet< T >::operator+= | ( | const T & | obj | ) |
| inline

Include the specified objects value into the set.

If the objects value is already in the set then the object is not included.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

template<class T>

PSet& PSet< T >::operator-= | ( | const T & | obj | ) |
| inline

Remove the objects value from the set.

If the `AllowDeleteObjects` option is set then the object is also deleted.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

template<class T>

PBoolean PSet< T >::operator[] | ( | const T & | key | ) | const
| inline

Determine if the value of the object is contained in the set.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

Returns
  true if the object value is in the set.

Parameters

  key | Key to look for in the set.

The documentation for this class was generated from the following file:

- dict.h